############################################################ {COPYRIGHT-TOP} ###
# IBM Confidential
# OCO Source Materials
# Tivoli Common Reporting Infrastructure
# 5724-Q87
#
# (c) Copyright IBM Corp. 2007
#
# The source code for this program is not published or otherwise
# divested of its trade secrets, irrespective of what has been
# deposited with the U.S. Copyright Office.
############################################################ {COPYRIGHT-END} ##
# wsadmin jython script for creating a shared library.
# The shared library is associated with the classloader of the
# application server, so all applications running in the application
# server will use the same classes in the shared library.

import sys

#--------------------------------------------------------------
# set up globals
#--------------------------------------------------------------
global AdminConfig


#-----------------------------------------
# Usage
#-----------------------------------------
def printUsage():
    print "Usage:  <was_profile_dir>/bin/wsadmin -lang jython -f addSharedLib.py <cellName> <nodeName> <serverName> <installDir>"
    print "   where <was_profile_dir>   is your was profile directory"
    print "         <cellName>          is the cell name of the server"
    print "         <nodeName>          is the node name of the server"
    print "         <serverName>        is the server name of the server"
    print "         <installDir>        is the path of the TCR installation"


###############################################################################
# Main block -- script execution starts here
###############################################################################

# Uncomment the following line to enable tracing to the wsadmin.traceout file
# AdminControl.trace('com.ibm.*=all=enabled')
# Verify the correct number or parameters was passed in
if not (len(sys.argv) == 4):
   sys.stderr.write("Invalid number of arguments\n")
   printUsage()
   sys.exit(101)

# retrieve the cell name
cellName = sys.argv[0]

# retrieve the node name
nodeName = sys.argv[1]

# retrieve the server name
serverName = sys.argv[2]

# retrieve the install directory
installDir = sys.argv[3]

print "Executing add function with the following parameters:"
print "   Cell: " + cellName + "."
print "   Node: " + nodeName + "."
print "   Server: " + serverName + "."
print "   InstallDir: " + installDir + "."

serverLookup = '/Cell:' + cellName + '/Node:' + nodeName + '/Server:' + serverName + '/'
serverID = AdminConfig.getid( serverLookup )

jvm = AdminConfig.list('JavaVirtualMachine', serverID)

import java
lineSeparator = java.lang.System.getProperty('line.separator')
arrayJVMs = jvm.split(lineSeparator)
cjvm = arrayJVMs[0]

propertyName = "com.ibm.tivoli.reporting.installdir"
propertyDesc = "Tivoli Common Reporting Home"

attr_name  = ['name', propertyName]
attr_value = ['value', installDir]
attr_required = ['required', "false"]
attr_description = ['description', propertyDesc]
attr_list = [attr_name, attr_value, attr_required, attr_description]
property=['systemProperties',[attr_list]]
AdminConfig.modify(cjvm, [property])
print "Custom property, " + propertyName + " = " + installDir + " :: " + propertyDesc + ", has been added to the JVM for server " + serverName + "."

AdminConfig.save()