import sys

global AdminConfig
global AdminControl

#-----------------------------------------
# Usage
#-----------------------------------------
def printUsage():
    print "Usage:  <was_profile_dir>/bin/wsadmin -lang jython -f addUserRole.py <role> <username>"
    print "   where <was_profile_dir>   is your was profile directory"
    print "         <role>              is the administrative role you want to associate the user with"
    print "         <username>          is the user to associate with the administrative role"


###############################################################################
# Main block -- script execution starts here
###############################################################################

# Verify the correct number or parameters was passed in
if not (len(sys.argv) == 2):
   sys.stderr.write("Invalid number of arguments\n")
   printUsage()
   sys.exit(101)

# retrieve the role
role = sys.argv[0]

# retrieve the user
username = sys.argv[1]

userData = AdminTask.searchUsers( '-uid ' + username ).split( lineSeparator )

if ( len(userData) != 1 ):
    sys.sterr.write("Invalid username.")
    sys.exit(101)

userRoleInfo = AdminTask.listAuthorizationGroupsForUserID( '-userid ' + username )
userRoleInfoList = userRoleInfo.replace( "{", "" ).replace( "}", "" ).replace( " ", "" ).split( "," )
roleFound = 0

for userRole in userRoleInfoList:
    print "userRole-" + userRole
    if ( userRole.startswith(role + "=" )):
        print "Found the role = " + role
        roleFound = 1
        emptyRole = role + "=[]"

        if (len(userRole) == len(emptyRole)):
            print "User does not have this role."
            AdminTask.mapUsersToAdminRole( '-roleName ' + role + ' -userids ' + username )
            AdminTask.createGroup( '-cn TSM_AdminCenter' )
            AdminTask.mapGroupsToAdminRole( '-roleName ' + role + ' -groupids TSM_AdminCenter' )
            AdminConfig.save()
        else:
            print "User has this role already."
            sys.exit(101)

if ( not roleFound ):
    print "User does not have this role."
    AdminTask.mapUsersToAdminRole( '-roleName ' + role + ' -userids ' + username )
    AdminTask.createGroup( '-cn TSM_AdminCenter' )
    AdminTask.mapGroupsToAdminRole( '-roleName ' + role + ' -groupids TSM_AdminCenter' )
    AdminConfig.save()
