############################################################ {COPYRIGHT-TOP} ###
# IBM Confidential
# OCO Source Materials
# Tivoli Common Reporting Infrastructure
# 5724-Q87
#
# (c) Copyright IBM Corp. 2007
#
# The source code for this program is not published or otherwise
# divested of its trade secrets, irrespective of what has been
# deposited with the U.S. Copyright Office.
############################################################ {COPYRIGHT-END} ##

import sys

#-----------------------------------------
# Usage
#-----------------------------------------
def printUsage():
    print "Usage:  <was_profile_dir>/bin/wsadmin -lang jython -f addSharedLib.py <cellName> <nodeName> <serverName> <installDir>"
    print "   where <was_profile_dir>   is your was profile directory"
    print "         <cellName>          is the cell name of the server"
    print "         <nodeName>          is the node name of the server"
    print "         <serverName>        is the server name of the server"
    print "         <installDir>        is the path of the TCR installation"

###############################################################################
# Main block -- script execution starts here
###############################################################################

# Uncomment the following line to enable tracing to the wsadmin.traceout file
# AdminControl.trace('com.ibm.*=all=enabled')

# Verify the correct number or parameters was passed in
if not (len(sys.argv) == 4):
   sys.stderr.write("Invalid number of arguments\n")
   printUsage()
   sys.exit(101)

# retrieve the cell name
cellName = sys.argv[0]

# retrieve the node name
nodeName = sys.argv[1]

# retrieve the server name
serverName = sys.argv[2]

# retrieve the install directory
installDir = sys.argv[3]

AdminApp.install( installDir + '/installableApps/tcr_v1.1.1.ear', '[ -server ' + serverName + ' -appname tcr -MapWebModToVH [[.* .* admin_host]] -MapRolesToUsers [["reportAdministrator" No Yes "" "reportAdministrator"] ["reportViewer" No Yes "" "reportViewer"]] ]' )

AdminConfig.save()
