############################################################ {COPYRIGHT-TOP} ###
# IBM Confidential
# OCO Source Materials
# Tivoli Common Reporting Infrastructure
# 5724-Q87
#
# (c) Copyright IBM Corp. 2007
#
# The source code for this program is not published or otherwise
# divested of its trade secrets, irrespective of what has been
# deposited with the U.S. Copyright Office.
############################################################ {COPYRIGHT-END} ##
import sys


rptAdmin = 'reportAdministrator'
rptViewer = 'reportViewer'
rptAdminSec = ''
rptViewerSec = ''

authTable = AdminConfig.getid('/AuthorizationTableExt:admin-authz.xml/')
secRoleListId = AdminConfig.getid('/AuthorizationTableExt:admin-authz.xml/SecurityRoleExt:/')
secRoleList = AdminConfig.list('SecurityRoleExt').split(lineSeparator)

for secRole in secRoleList:
    secRoleAttrs = AdminConfig.show(secRole).split(lineSeparator)
    for secRoleAttr in secRoleAttrs:
        if ( not ( secRoleAttr.find(rptAdmin) == -1 ) ):
            AdminConfig.create('RoleAssignmentExt', authTable, '[ [ role ' + secRole + ' ] ]')
            rptAdminSec = secRole
        if ( not ( secRoleAttr.find(rptViewer) == -1 ) ):
            AdminConfig.create('RoleAssignmentExt', authTable, '[ [ role ' + secRole + ' ] ]')
            rptViewerSec = secRole


roleAssignmentsList = AdminConfig.list('RoleAssignmentExt').split(lineSeparator)
for roleAssignment in roleAssignmentsList:
    roleAttrs = AdminConfig.show(roleAssignment).split(lineSeparator)
    for roleAttr in roleAttrs:
        if ( not ( roleAttr.find(rptAdminSec) == -1 ) ):
            AdminConfig.create( 'GroupExt', roleAssignment, '[ [ name ' + rptAdmin + ' ] ]')
        if ( not ( roleAttr.find(rptViewerSec) == -1 ) ):
            AdminConfig.create( 'GroupExt', roleAssignment, '[ [ name ' + rptViewer + ' ] ]')

AdminConfig.save()
