############################################################ {COPYRIGHT-TOP} ###
# IBM Confidential
# OCO Source Materials
# Tivoli Common Reporting Infrastructure
# 5724-Q87
#
# (c) Copyright IBM Corp. 2007
#
# The source code for this program is not published or otherwise
# divested of its trade secrets, irrespective of what has been
# deposited with the U.S. Copyright Office.
############################################################ {COPYRIGHT-END} ##
####

import sys

global AdminConfig
global AdminControl

#-----------------------------------------
# Usage
#-----------------------------------------
def printUsage():
    print "Usage:  <was_profile_dir>/bin/wsadmin -lang jython -f setupDatasource.py <cellName> <nodeName> <serverName> <installDir>"
    print "   where <was_profile_dir>   is your was profile directory"
    print "         <cellName>          is the cell name of the server"
    print "         <nodeName>          is the node name of the server"
    print "         <serverName>        is the server name of the server"
    print "         <installDir>        is the path of the TCR installation"


###############################################################################
# Main block -- script execution starts here
###############################################################################

# Verify the correct number or parameters was passed in
if not (len(sys.argv) == 4):
   sys.stderr.write("Invalid number of arguments\n")
   printUsage()
   sys.exit(101)

# retrieve the cell name
cellName = sys.argv[0]

# retrieve the node name
nodeName = sys.argv[1]

# retrieve the server name
serverName = sys.argv[2]

# retrieve the install directory
installDir = sys.argv[3]

#-------------------------------------------------------------------------------
# Initialize the JDBC Provider
#-------------------------------------------------------------------------------

# The alias might not be used later but for now will leave them here in the script
aliasName = "DerbyAlias"
aliasDesc = "Derby Connection"
aliasUser = "db2admin"
aliasPW   = "pstectec"

providerCP    = "${DERBY_JDBC_DRIVER_PATH}/derby.jar"
providerImplClass = "org.apache.derby.jdbc.EmbeddedConnectionPoolDataSource"
providerName  = "Derby JDBC Provider"
providerDesc  = "Derby embedded non-XA  JDBC Provider. This provider is only configurable in version 6.0.2 and later nodes"

# The dsDBName is still unknown but I have it defined below
dsName   = "Tivoli Common Reporting Data Source"
dsDesc   = "Tivoli Common Reporting's default Data Source"
dsDBName = installDir + "/data/database/RPTDB"

#-------------------------------------------------------------------------------
# Create JAASAuthData alias
#-------------------------------------------------------------------------------
#print "Creating JAASAuthData alias ..... "

#cell = AdminControl.getCell()
#fullCellName = "/Cell:" + cell + "/Security:/"
#sec = AdminConfig.getid(fullCellName)

#alias_attr_name = ['alias', aliasName]

#alias_attr_desc = ['description', aliasDesc]

#alias_attr_userid = ['userId', aliasUser]

#alias_attr_pw = ['password', aliasPW]

#alias_attrs = [alias_attr_name, alias_attr_desc, alias_attr_userid, alias_attr_pw]

#authdata = AdminConfig.create('JAASAuthData', sec, alias_attrs)

#print "Saving creation of JAASAuthData alias configuration changes made so far..."
#AdminConfig.save()
#print "   Saved configuration changes so far."

#print "JAASAuthData authentication alias has been created successfully."

#-------------------------------------------------------------------------------
# Create the JDBCProvider
#-------------------------------------------------------------------------------
print "Creating JDBCProvider....."

# I have tcrCell hardcoded here for now. This is probably not the best idea but will
# leave it here for now.
cell = AdminConfig.getid('/Cell:' + cellName + '/')

provider_attr_cp = ['classpath', providerCP]

provider_attr_implclass = ['implementationClassName', providerImplClass]

provider_attr_name = ['name', providerName]

provider_attr_desc = ['description', providerDesc]

provider_attrs = [provider_attr_cp, provider_attr_implclass, provider_attr_name, provider_attr_desc]

provider = AdminConfig.create('JDBCProvider', cell, provider_attrs)

print "Saving creation of JDBCProvider configuration changes made so far..."
AdminConfig.save()
print "   Saved all configuration changes."

print "JDBCProvider has been created successfully."

#-------------------------------------------------------------------------------
# Create DataSource
#-------------------------------------------------------------------------------
print "Creating DataSource ..... "

ds_attr_name = ['name', dsName]

ds_attr_desc = ['description', dsDesc]

ds_attrs = [ds_attr_name, ds_attr_desc]

dataSource = AdminConfig.create('DataSource', provider, ds_attrs)

ds_props = AdminConfig.create('J2EEResourcePropertySet', dataSource, [])

ds_dbname_name = ['name', 'databaseName']

ds_dbname_type = ['type', 'java.lang.String']

ds_dbname_value = ['value', dsDBName]

ds_dbname_prop = [ds_dbname_name, ds_dbname_type, ds_dbname_value]

AdminConfig.create('J2EEResourceProperty', ds_props, ds_dbname_prop)

reportDS = "jdbc/TivoliCR_DS"
ds_mod_jndi = ['jndiName', reportDS]

ds_mod_alias  = ['authDataAlias', aliasName]

derbyHelper = "com.ibm.websphere.rsadapter.DerbyDataStoreHelper"
ds_mod_helper = ['datasourceHelperClassname', derbyHelper]

# ds_mod_propr = [ds_mod_jndi, ds_mod_alias, ds_mod_helper]

ds_mod_propr = [ds_mod_jndi, ds_mod_helper]

AdminConfig.modify(dataSource, ds_mod_propr)

print "Saving creation of Datasource configuration changes made so far"
AdminConfig.save()
print "   Saved all configuration changes"

print "Datasource has been created successfully."
