############################################################ {COPYRIGHT-TOP} ###
# IBM Confidential
# OCO Source Materials
# Tivoli Common Reporting Infrastructure
# 5724-Q87
#
# (c) Copyright IBM Corp. 2007
#
# The source code for this program is not published or otherwise
# divested of its trade secrets, irrespective of what has been
# deposited with the U.S. Copyright Office.
############################################################ {COPYRIGHT-END} ##
import sys

#--------------------------------------------------------------
# set up globals
#--------------------------------------------------------------
global AdminTask

#-----------------------------------------
# Usage
#-----------------------------------------
def printUsage():
    print "Usage:  <was_profile_dir>/bin/wsadmin -lang jython -f addUserRoleTCR.py <role> <username>"
    print "   where <was_profile_dir>   is your was profile directory"
    print "         <role>              is the TCR role to add your user to: reportAdministrator, reportViewer"


###############################################################################
# Main block -- script execution starts here
###############################################################################

adminRole = "reportAdministrator"
viewerRole = "reportViewer"

# Verify the correct number or parameters was passed in
if not (len(sys.argv) == 2):
    sys.stderr.write("Invalid number of arguments\n")
    printUsage()
    sys.exit(101)

AdminTask.createGroup( '-cn ' + adminRole )
AdminTask.createGroup( '-cn ' + viewerRole )

role = sys.argv[0]
username = sys.argv[1]

if  ( not ( role == viewerRole ) ) and ( not ( role == adminRole ) ):
    sys.stderr.write("Invalid role: " + role + ". Valid roles are " + adminRole + " and " + viewerRole + ".")
    sys.exit(101);

else :
    AdminTask.addMemberToGroup( '-memberUniqueName uid=' + username + ',o=defaultWIMFileBasedRealm -groupUniqueName cn=' + role + ',o=defaultWIMFileBasedRealm')

AdminTask.mapGroupsToAdminRole( '-roleName ' + adminRole + ' -groupids ' + adminRole )
AdminTask.mapGroupsToAdminRole( '-roleName ' + viewerRole + ' -groupids ' + viewerRole )

security = AdminConfig.list( 'Security' )
AdminConfig.modify( security, [['appEnabled', 'true']] )

print "Save configuration"
AdminConfig.save()